#include<stdio.h>
#include<string.h>
#include<stdlib.h>

struct Prijava
{
	char *ime_prezime;
	char *mesto;
	int sprema;
	int sifra;
	struct Prijava *next;
	
};

char *alociraj_string(int n)
{
	char *p=NULL;
	
	p=(char *)malloc(n*sizeof(char));
	if(p==NULL)
	{
		printf("Greska pri alociranju memorije!\n");
		exit(0);
	}
	
	return (p);
}

void dodaj(struct Prijava **glava,struct Prijava *temp)
{
	if((temp->sprema>=3) && (temp->sprema<=8))
	{
		if(*glava==NULL)
		{
			temp->next=NULL;
			(*glava)=temp;
		}
		else
		{
			temp->next=(*glava);
			(*glava)=temp;
		}
	}
}

struct Prijava *form(FILE *f)
{
	struct Prijava *glava=NULL;
	struct Prijava *temp=NULL;
	int ukupno;
	int i;
	char niz[102];
	
	fgets(niz,100,f);
	if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
	ukupno=atoi(niz);
	
	for(i=0; i<ukupno; i++)
	{
		
		temp=(struct Prijava *)malloc(sizeof(struct Prijava));
		if(temp==NULL)
		{
			printf("Greska pri alociranju memorije!\n");
			exit(0);
		}
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->ime_prezime=alociraj_string(strlen(niz)-1);
		strcpy(temp->ime_prezime,niz);
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->mesto=alociraj_string(strlen(niz)-1);
		strcpy(temp->mesto,niz);
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->sprema=atoi(niz);
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->sifra=atoi(niz);
		
		
		dodaj(&glava,temp);
	}
	
	return (glava);
}

void ispis(struct Prijava *glava)
{
	if(glava==NULL)
	{
		printf("Lista je prazna!\n");
	}
	else
	{
		while(glava!=NULL)
		{
			printf("Ime i prezime: %s\n",glava->ime_prezime);
			printf("Mesto: %s\n",glava->mesto);
			printf("Strucna sprema: %d\n",glava->sprema);
			printf("Sifra posla: %d\n",glava->sifra);
			
			glava=glava->next;
		}
	}
}

int maks(struct Prijava *glava,int sif)
{
	struct Prijava *temp=NULL;
	struct Prijava *pom=NULL;
	
	pom=glava;
	int max=0;
	

	
	while(pom!=NULL)
	{
		if(pom->sifra==sif)
		{
		    temp=pom;
			break;
		}
		else pom=pom->next;
	}
	max=temp->sprema;
		
	while(pom!=NULL)
	{
		if((pom->sprema>max) && (pom->sifra==sif))
		{
			max=pom->sprema;
			pom=pom->next;
		}
		else pom=pom->next;
	}
	
	return (max);
}

void obrisi(struct Prijava **glava,struct Prijava *pom,struct Prijava *prethodni)
{
	struct Prijava *temp=NULL;
	
			if(prethodni==NULL)
			{
				temp=pom;
				pom=pom->next;
				(*glava)=pom;
				free(temp);
			}
			else
			{
				temp=pom;
				prethodni->next=pom->next;
				pom=pom->next;
				free(temp);
			}			
}
void najbolji(struct Prijava **glava)
{
	struct Prijava *pom=NULL;
	struct Prijava *prethodni=NULL;
	
	pom=(*glava);
	
	while(pom!=NULL)
	{
		if(pom->sprema<maks(pom,pom->sifra))
		{
			obrisi(glava,pom,prethodni);
			pom=(*glava);
		}
		else
		{
			prethodni=pom;
			pom=pom->next;
		}
	}
}


int main(int argc,char **argv)
{

	struct Prijava *glava=NULL;
	FILE *f=NULL;
	char sif[102];
	int s;
	int najveci;
	
	if(argc!=2)
	{
		printf("Netacan broj argumenata!\n");
		exit(0);
	}

	
	f=fopen(argv[1],"r");
	if(f==NULL)
	{
		printf("Greska pri otvaranju fajla!\n");
		exit(0);
	}
	
	glava=form(f);
	ispis(glava);

	fclose(f);
	
	printf("\n");
	printf("\n");
	
	printf("Unesite sifru posla: ");
	
	scanf("%d",&s);
	najveci=maks(glava,s);
	getchar();
	
	printf("Najveca strucna sprema za posao sa sifrom %d je %d\n",s,najveci);
	
	printf("\n");
	printf("\n");
	
	najbolji(&glava);
	
	printf("Lista najboljih kandidata: \n");
	ispis(glava);
	
	return 0;
}
