#include<stdio.h>
#include<string.h>
#include<stdlib.h>

struct Glas
{
		char *ime;
		int ocena_tezina;
		int ocena_nastupa;
		int ocena_pevanja;
		char *komentar;
		struct Glas *levi;
		int balans;
		struct Glas *desni;
};

char *alociraj_string(int n)
{
	char *p=NULL;
	
	p=(char *)malloc(n*sizeof(char));
	if(p==NULL)
	{
		printf("Greska pri alociranju memorije!\n");
		exit(0);
	}
	
	return (p);
}

int dubina(struct Glas *p)
{
	int dd=0,dl=0;
	
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		
		if(dd>dl) return (++dd);
		else return (++dl);
	}
	else return 0;
}

void lrotacija(struct Glas **p)
{
	struct Glas *pomd=NULL,*poml=NULL;
	
	poml=(*p);
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	(*p)=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct Glas **p)
{
	struct Glas *pomd=NULL,*poml=NULL;
	
	pomd=(*p);
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	(*p)=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

float srednja(struct Glas *p)
{
	float s=0;
	int ukupno=3;
	float suma=0;
	
	suma=p->ocena_nastupa+p->ocena_pevanja+p->ocena_tezina;
	
	s=(float)suma/(float)ukupno;
	
	return (s);
}

int dodaj(struct Glas **p,struct Glas *temp)
{
	struct Glas *t=(*p);
	int inkrement;
	int rezultat=0;
	
	if(t==NULL)
	{
		t=temp;
		t->balans=0;
		rezultat=1;
	}
	else
	{
		if(srednja(temp)>srednja(t)) inkrement=dodaj(&(t->desni),temp);
		else inkrement=-dodaj(&(t->levi),temp);
		
		t->balans=t->balans+inkrement;
		
		if((t->balans!=0) && (inkrement!=0))
		{
			if(t->balans<-1)
			{
				if((t->levi->balans)<0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans>1)
			{
				if(t->desni->balans>0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rezultat=1;
		}
	}
	
	(*p)=t;
	
	return (rezultat);
}

struct Glas *form(FILE *f)
{
	struct Glas *koren=NULL;
	struct Glas *temp=NULL;
	int ukupno;
	int i;
	char niz[102];
	
	fgets(niz,100,f);
	if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
	ukupno=atoi(niz);
	
	for(i=0; i<ukupno; i++)
	{
		temp=(struct Glas *)malloc(sizeof(struct Glas));
		if(temp==NULL)
		{
			printf("Greska pri alociranju memorije!\n");
			exit(0);
		}
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->ime=alociraj_string(strlen(niz)-1);
		strcpy(temp->ime,niz);
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->ocena_tezina=atoi(niz);
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->ocena_nastupa=atoi(niz);
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->ocena_pevanja=atoi(niz);
		
		if(temp->ocena_pevanja>5)
		{
			temp->komentar=alociraj_string(strlen("Uspesan")+1);
			strcpy(temp->komentar,"Uspesan");
		}
		else
		{
			temp->komentar=alociraj_string(strlen("Neuspesan")+1);
			strcpy(temp->komentar,"Neuspesan");
		}
		
		temp->levi=temp->desni=NULL;
		
		dodaj(&koren,temp);
	}
	

	return (koren);
}

void ispis(struct Glas *koren)
{
	
	if(koren)
	{
		ispis(koren->desni);
		printf("Ime: %s\t\tOcena tezine: %d\t\tOcena nastupa: %d\t\tOcena pevanja: %d\t\tKomentar: %s\t\tBalnas: <%d>\n",koren->ime,koren->ocena_tezina,koren->ocena_nastupa,koren->ocena_pevanja,koren->komentar,koren->balans);
		ispis(koren->levi);
	}
}

int main(int argc,char **argv)
{

	struct Glas *koren=NULL;
	FILE *f=NULL;
	
	if(argc!=2)
	{
		printf("Netacan broj argumenata!\n");
		exit(0);
	}

	
	f=fopen(argv[1],"r");
	if(f==NULL)
	{
		printf("Greska pri otvaranju fajla!\n");
		exit(0);
	}
	
	koren=form(f);
	printf("\n");
	printf("\n");
	ispis(koren);

	fclose(f);
	
	return 0;
}
