#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct avl
{
	char ime[30];
	int ocenat,ocenan,ocenap,balans;
	char komentar[10];
	struct avl *levo,*desno;
}drvo;

int dubina(drvo *p)
{
	int dd=0,dl=0;
	if(p)
	{
		if(p->levo) dl=dubina(p->levo);
		if(p->desno) dd=dubina(p->desno);
		
		if(dl>dd)
		return ++dl;
		else
		return ++dd;
	}
	else
	return 0;
}

void lrotacija(drvo **p)
{
	drvo *poml,*pomd;
	poml=*p;
	pomd=(*p)->desno;
	poml->desno=pomd->levo;
	pomd->levo=poml;
	*p=pomd;
	
	pomd->balans=dubina(pomd->desno)-dubina(pomd->levo);
	poml->balans=dubina(poml->desno)-dubina(poml->levo);
}

void drotacija(drvo **p)
{
	drvo *poml,*pomd;
	pomd=*p;
	poml=(*p)->levo;
	pomd->levo=pomd->desno;
	poml->desno=pomd;
	*p=poml;
	
	pomd->balans=dubina(pomd->desno)-dubina(pomd->levo);
	poml->balans=dubina(poml->desno)-dubina(poml->levo);
}

int dodaj(drvo **p, drvo *temp)
{
	int ink=0,rezultat=0;
	if((*p)==NULL)
	{
		(*p)=temp;
		(*p)->levo=NULL;
		(*p)->desno=NULL;
		(*p)->balans=0;
		rezultat=1;
	}
	else
	{
		float a,b;
		a=(temp->ocenap+temp->ocenat+temp->ocenan)/3.0;
		b=((*p)->ocenap+(*p)->ocenat+(*p)->ocenan)/3.0;
		if(a < b)
		ink=-dodaj(&(*p)->levo,temp);
		else
		ink=dodaj(&(*p)->desno,temp);
		
		(*p)->balans+=ink;
		
		if((*p)->balans!=0 && ink!=0)
		{
			if((*p)->balans<-1)
			{
				if((*p)->levo->balans<0) drotacija(&(*p));
				else
				{
					lrotacija(&(*p)->levo);
					drotacija(&(*p));
				}
			}
			else
			if((*p)->balans>1)
			{
				if((*p)->desno->balans>0) lrotacija(&(*p));
				else
				{
					drotacija(&(*p)->desno);
					lrotacija(&(*p));
				}
			}
			else
			rezultat=1;
		}
	}
	return rezultat;
}


drvo *form(FILE *f)
{
	drvo *p=NULL;
	int n,i;
	fscanf(f,"%d",&n);
	for(i=0;i<n;i++)
	{
		drvo *temp;
		temp=malloc(sizeof(drvo));
		fscanf(f,"%s",temp->ime);
		fscanf(f,"%d%d%d",&temp->ocenat,&temp->ocenan,&temp->ocenap);
		if(temp->ocenap>5)
		strcpy(temp->komentar,"Uspesan");
		else
		strcpy(temp->komentar,"Neuspesan");
		dodaj(&p,temp);
	}
	return p;
}

void ispis(drvo *p)
{
	if(p)
	{
		ispis(p->desno);
		printf("Ime:%s OCENA_TEZINE_PESME: %d, OCENA_NASTUPA: %d, OCENA_PEVANJA: %d, Uspeh: %s, Balans: %d\n",p->ime,p->ocenat,p->ocenan,p->ocenap,p->komentar,p->balans);
		ispis(p->levo);
	}
}

void nadji(char *a,char *b,drvo *p)
{
	if(p)
	{
	float c;
	if(strcmp(a,p->ime)==0)
	{
		c=(p->ocenap+p->ocenat+p->ocenan+10.0)/4.0;
		if(c>5.0)
		strcpy(p->komentar,"Uspesan");
		else
		strcpy(p->komentar,"Neuspesan");
	}
	if(strcmp(b,p->ime)==0)
	{
		c=(p->ocenap+p->ocenat+p->ocenan+5.0)/4.0;
		if(c>5.0)
		strcpy(p->komentar,"Uspesan");
		else
		strcpy(p->komentar,"Neuspesan");
	}
	nadji(a,b,p->levo);
	nadji(a,b,p->desno);
	}
}
void Nagrada(drvo *p)
{
	int a,b;
	char ime1[20],ime2[20];
	printf("ime prvog :");
	scanf("%s",ime1);
	printf("\nime drugog :");
	scanf("%s",ime2);
	nadji(ime1,ime2,p);
}

void brisi(drvo *p,drvo **q)
{
	if(p)
	{
	brisi(p->levo,&(*q));
	brisi(p->desno,&(*q));
	if(strcmp(p->komentar,"Uspesan")==0)
	{
		p->levo=NULL;
		p->desno=NULL;
		dodaj(&(*q),p);
	}
	else
	free(p);
	}
}

void Ocena(drvo *p,int broj,drvo **pom,int min)
{
	if(p)
	{
		printf("%d",abs(p->ocenap-broj));
	if(min>abs(p->ocenap-broj))
	{
		min=abs(p->ocenap-broj);
		(*pom)=p;
		printf("%d",p->ocenap);
	}
	Ocena(p->levo,broj,&(*pom),min);
	Ocena(p->desno,broj,&(*pom),min);
	}
}


main(int argc,char **argv)
{
	if(argc!=2)
	{
		printf("unesite ime datoteke iz koje se cita\n");
		exit(0);
	}
	drvo *p=NULL,*q=NULL,*pom=NULL;
	int broj;
	FILE *f=fopen(argv[1],"r");
	p=form(f);
	ispis(p);
	Nagrada(p);
	brisi(p,&q);
	ispis(q);
	p=q;
	printf("Unesi broj:");
	scanf("%d",&broj);
	int min;
	pom=p;
	min=abs(p->ocenap-broj);
	Ocena(p,broj,&pom,min);
	if(pom)
	printf("Najuspesniji:\nIme:%s OCENA_TEZINE_PESME: %d, OCENA_NASTUPA: %d, OCENA_PEVANJA: %d, Uspeh: %s, Balans: %d\n",pom->ime,pom->ocenat,pom->ocenan,pom->ocenap,pom->komentar,pom->balans);
}

