#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _DETE DETE;

struct _DETE
{
	char ime[30];
	int korak;
	char igrao;
	struct _DETE *sledeci;
};

DETE *element(char *ime, int k)
{
	DETE *temp;
	temp = (DETE *) malloc(sizeof(DETE));
	
	if (!temp)
	{
		perror("Ne moze da alocira dete!\n");
		exit(1);
	}
	strcpy(temp->ime, ime);
	temp->korak = k;
	temp->igrao = 0;
	temp->sledeci = NULL;
	
	return temp;
}

void dodaj(DETE **glava, DETE *element)
{
	DETE *t = *glava;
	
	if(!t)
		element->sledeci = element;
	else
	{
		element->sledeci = t->sledeci;
		t->sledeci = element;
	}
	*glava = element;
}

DETE *form(FILE *f, DETE **p)
{
	int broj, k, i;
	char ime[30];
	DETE *n, *prvo = NULL;
	
	fscanf(f, "%d", &broj);
	
	for (i = 0; i < broj; i++)
	{
		fscanf(f, "%s", ime);
		fscanf(f, "%d", &k);
		n = element(ime, k);
		if (i)
			dodaj(p, n);
		else
			prvo = n;
	}
	
	return prvo;
}

void ispis(DETE *glava)
{
	if (!glava)
		return;
		
	DETE *t;
	t = glava->sledeci;
	
	while (t != glava)
	{
		printf("Ime %s, korak %d\n", t->ime, t->korak);
		t = t->sledeci;
	}
	
	printf("Ime %s, korak %d\n", t->ime, t->korak);
}

int koraci(DETE **g, DETE **p)
{
	DETE *glava, *prvo, *t;
	int i;
	
	glava = *g;
	prvo = *p;
	i = prvo->korak-1;
	
	while(i)
	{
		glava = glava->sledeci;
		i--;
	}
	
	t = glava->sledeci;
	
	if (t->igrao)
		return 0;
		
	glava->sledeci = prvo;
	prvo->sledeci = t->sledeci;
	prvo->igrao = 1;
	t->sledeci = NULL;
	
	*g = prvo;
	*p = t;
	
	return 1;
}

void igra(DETE **g, DETE **p)
{
	while (koraci(g, p));
}

void nadji(DETE *g, int k)
{
	while (k)
	{
		g = g->sledeci;
		k--;
	}
	printf("Ime %s, korak %d\n", g->ime, g->korak);
}

int main(int argc, char **argv)
{
	if (argc != 2)
	{
		perror("Lose prosledjeni parametri\n");
		exit(1);
	}
	
	FILE *f;
	DETE *prvo, *glava;
	prvo = NULL;
	glava = NULL;
	
	f = fopen(argv[1], "r");
	prvo = form(f, &glava);
	ispis(glava);
	printf("\nZa prvo dete:\n");
	nadji(glava, prvo->korak);
	igra(&glava, &prvo);
	printf("\nPosle igre:\n");
	ispis(glava);
	
	return 0;
}
