#include<stdio.h>
#include<stdlib.h>
#include<string.h>

enum {CRVENO, CRNO};

#define novi(x) x=(struct cvor *)malloc(sizeof(struct cvor))

struct cvor {
	char ime[30];
	int ocena_tezine_pesme;
	int ocena_nastupa;
	int ocena_pevanja;
	float srednja_ocena;
	char komentar[15];
	int boja;
	struct cvor *levi, *desni, *roditelj;
	};
	
void drotacija(struct cvor **t){
	struct cvor *x, *y;
	
	x=*t;
	y=x->levi;
	
	x->levi=y->desni;
	y->desni->roditelj=x;
	
	if(x==x->roditelj->levi) x->roditelj->levi=y;
	else x->roditelj->desni=y;
	
	y->desni=x;
	x->roditelj=y;
	
	*t=y;
	}
	
void lrotacija(struct cvor **t){
	struct cvor *x, *y;
	
	x=*t;
	y=x->desni;
	
	x->desni=y->levi;
	y->levi->roditelj=x;
	
	if(x==x->roditelj->levi) x->roditelj->levi=y;
	else x->roditelj->desni=y;
	
	y->levi=x;
	x->roditelj=y;
	
	*t=y;
	}
	
void bojefix(struct cvor **koren, struct cvor *z){
	struct cvor *t, *y;
	
	while((z->roditelj) && (z->roditelj==CRVENO)){
		if(z->roditelj==z->roditelj->roditelj->levi){
			y=z->roditelj->roditelj->desni;
			if((y) && (y->boja==CRVENO)){
				y->boja=CRNO;
				z->roditelj->boja=CRNO;
				z->roditelj->roditelj->boja=CRVENO;
				z=z->roditelj->roditelj;
				}
			else{
				if(z==z->roditelj->desni){
					z=z->roditelj;
					lrotacija(&z);
					z=z->levi;
					if(!z->roditelj) *koren=z;
					}
				z->roditelj->boja=CRNO;
				z->roditelj->roditelj->boja=CRVENO;
				t=z->roditelj->roditelj;
				drotacija(&t);
				z=z->roditelj->roditelj;
				}
			}
		else{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->boja==CRVENO)){
				y->boja=CRNO;
				z->roditelj->boja=CRNO;
				z->roditelj->roditelj->boja=CRVENO;
				z=z->roditelj->roditelj;
				}
			else{
				if(z==z->roditelj->levi){
					z=z->roditelj;
					drotacija(&z);
					z=z->desni;
					if(!z->roditelj) *koren=z;
					}
				z->roditelj->boja=CRNO;
				z->roditelj->roditelj->boja=CRVENO;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				z=z->roditelj->roditelj;
				}
			}
		
			}
		
		}
	
	
void dodaj (struct cvor **koren, struct cvor *temp){
	struct cvor *p, *q;
	
	p=*koren;
	q=NULL;
	
	while(p!=NULL){
		q=p;
		if(temp->srednja_ocena<p->srednja_ocena) p=p->levi;
		else p=p->desni;
		}
	
	if(!q) *koren=temp;
	else {
		temp->roditelj=q;
		if(temp->srednja_ocena<q->srednja_ocena) q->levi=temp;
		else q->desni=temp;
		}
		
	bojefix(koren, temp);
	}
	
float srednja (int tezina, int nastup, int pevanje){
	return ((tezina+nastup+pevanje)/3);
	}

float nova_srednja (int tezina, int nastup, int pevanje, int novo){
	return ((tezina+nastup+pevanje+novo)/4);
	}


void formiraj (struct cvor **koren){
	int N, i;
	struct cvor *temp;
	printf("Unesite broj kandidata:\n");
	scanf("%d",&N);
	char kom[10];
	
	for(i=0; i<N; i++){
		novi(temp);
		if(!temp){
			printf("Greska pri alociranju memorije!\n");
			exit(1);
			}
		printf("Unesite ime %d. kandidata:\n",i+1);
		scanf("%s",temp->ime);
		
		printf("Unesite ocenu tezine %d. kandidata:\n",i+1);
		scanf("%d",&temp->ocena_tezine_pesme);
		
		printf("Unesite ocenu nastupa %d. kandidata:\n",i+1);
		scanf("%d",&temp->ocena_nastupa);
		
		printf("Unesite ocenu pevanja %d. kandidata:\n",i+1);
		scanf("%d",&temp->ocena_pevanja);

		if(temp->ocena_pevanja>5) strcpy(temp->komentar, "Uspesan");
		else strcpy(temp->komentar, "Neuspesan");
		
		temp->srednja_ocena=srednja(temp->ocena_tezine_pesme, temp->ocena_nastupa, temp->ocena_pevanja);
		
		temp->levi=temp->desni=temp->roditelj=NULL;
		temp->boja=CRVENO;
		
		dodaj(koren, temp);
		
		}
	}


void stampaj(struct cvor *koren){
	if(koren){
		stampaj(koren->desni);
		
		printf("Ime kandidata je:  %s\n", koren->ime);
		printf("Ocena tezine pesme kandidata je:  %d\n", koren->ocena_tezine_pesme);
		printf("Ocena nastupa kandidata je:  %d\n", koren->ocena_nastupa);
		printf("Ocena pevanja kandidata je:  %d\n", koren->ocena_pevanja);
		printf("Srednja ocena kandidata je:  %f\n", koren->srednja_ocena);
		printf("Komentar kandidata je:  %s\n", koren->komentar);
		printf("Boja:  ");
		if(koren->boja==CRVENO) printf("CRVENO\n");
		else printf("CRNO\n");
		
		stampaj(koren->levi);
		}
	}

/*
struct cvor *pobednik(struct cvor *koren, int ocena, int *razlika){
	if(koren){
	if((ocena-koren->ocena_pevanja)<*razlika)	
}
	}
*/

void brisi (struct cvor *koren, struct cvor **novo, char ime1[], char ime2[]){
	struct cvor *p, *q;
	int srednja;
	if(koren){
		brisi(koren->desni, novo, ime1, ime2);
		
		if ((strcmp(koren->ime, ime1)==0) || (strcmp(koren->ime, ime2)==0)){
			if(strcmp(koren->ime, ime1)==0){
				if(srednja=nova_srednja(koren->ocena_tezine_pesme, koren->ocena_nastupa, koren->ocena_pevanja, 5)>5);
						dodaj(novo, koren);
					}
			else {
			if(strcmp(koren->ime, ime2)==0)
				if(srednja=nova_srednja(koren->ocena_tezine_pesme, koren->ocena_nastupa, koren->ocena_pevanja, 10)>5);
						dodaj(novo, koren);
				}
			}
		else{
			if(strcmp(koren->komentar,"Uspesan")==0)	dodaj(novo, koren);
			}
			
		brisi(koren->levi, novo, ime1, ime2);
		}
	
}

main(){
	struct cvor *koren;
	struct cvor *novo;
	char ime1[30], ime2[30];
	
	koren=NULL;
	
	formiraj(&koren);
	
	stampaj(koren);
	
	printf("Unesite imena kandidata nagradjenih od strane publike:\n");
	scanf("%s", ime1);
	scanf("%s", ime2);
	
	brisi(koren, &novo, ime1, ime2);
	
	printf("Kandidati posle glasanja publike: \n");
	
	stampaj(novo);
	
	}






















