#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

#define novi(x) x = (struct drvo *)malloc(sizeof(struct drvo))

struct drvo{
	char ime[50];
	int tezina_pesme;
	int ocena_nastupa;
	int ocena_pevanja;
	float prosecna;
	int komentar;
	int balans;
	struct drvo *levi, *desni;
};

int dubina(struct drvo *p){
	int dd = 0, dl = 0;
	if(p)
	{
		if(p->levi)
			dl = dubina(p->levi);
		if(p->desni)
			dd = dubina(p->desni);
		if(dl > dd)
			return ++dl;
		else
			return ++dd;
	}
	else
		return 0;
}

void lrot(struct drvo **t){
	struct drvo *poml, *pomd;
	poml = *t;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*t = pomd;
	
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drot(struct drvo **t){
	struct drvo *poml, *pomd;
	pomd = *t;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*t = poml;
	
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void sredi(struct drvo **p){
	struct drvo *t;
	if(*p)
	{
		t = *p;
		if(t->balans < -1)
		{
			if(t->levi->balans < 0)
			{
				drot(&t);
			}
			else
			{
				lrot(&(t->levi));
				drot(&t);
			}
		}
		else
			if(t->balans > 1)
			{
				lrot(&t);
			}
			else
			{
				drot(&(t->desni));
				lrot(&t);
			}
		*p = t;
	}
}

int dodaj(struct drvo **p, struct drvo *q){
	int inkrement, rezultat;
	struct drvo *pom1, *pom2;
	pom1 = *p;
	pom2 = q;
	rezultat = 0;
	if(pom1 == NULL)
	{
		pom1 = pom2;
		rezultat = 1;
	}
	else
	{	
		if(pom2->prosecna > pom1->prosecna)
			inkrement  = dodaj(&(pom1->desni),pom2);
		else 
			inkrement = -dodaj(&(pom1->levi),pom2);
			
		pom1->balans += inkrement;
		if((inkrement != 0) && (pom1->balans != 0))
		{
			if(pom1->balans < -1)
			{
				if(pom1->levi->balans < 0) 
					drot(&pom1);
				else
				{
					lrot(&(pom1->levi));
					drot(&pom1);
				}
			}
			else
				if(pom1->balans > 1)
				{
					if(pom1->desni->balans > 0) 
						lrot(&pom1);
					else
					{
						drot(&(pom1->desni));
						lrot(&pom1);
					}
				}
			else
				rezultat = 1;
		}
	}
	*p = pom1;
	return rezultat;
}

struct drvo *form(){
	struct drvo *koren, *nov;
	int i, n;
	char s[50];
	koren = NULL;
	scanf("%d", &n);//broj takmicara
	for(i = 0; i < n; i++){
		novi(nov);
		getchar();
		gets(s);
		strcpy(nov->ime, s);
		scanf("%d %d %d",&nov->tezina_pesme, &nov->ocena_nastupa, &nov->ocena_pevanja);
		nov->prosecna = (float)((nov->tezina_pesme + nov->ocena_nastupa + nov->ocena_pevanja)/3);
		if(nov->ocena_pevanja > 5)
			nov->komentar = 1;
		else
			nov->komentar = 0;
		nov->levi = NULL;
		nov->desni = NULL;
		dodaj(&koren,nov);
		free(nov);
	}
	return koren;
}

void ispis(struct drvo *p){
	if(p)
	{
		ispis(p->desni);
		printf("%s\t%d\t%d\t%d\t\t%.2f\t", p->ime, p->tezina_pesme, p->ocena_nastupa, p->ocena_pevanja, p->prosecna);
		if(p->komentar == 1)
			printf("Uspesan!\t(%d)",p->balans);
		else
			printf("Neuspesan!\t(%d)",p->balans);
		ispis(p->levi);
	}
}
/*
 nadji(struct drvo *p ){
	int n = 0;
	if(p)
	{
		
	}
}

struct drvo *obrisi(struct drvo *p){
	struct drvo *pom;
	if(!p)
		return NULL;
	if((p->komentar == 0) && ((p->ocena_pevanja <= 5) || (p->prosecna <= 5)))
	{
		if((!p->levi) && (!p->desni))
		{
			free(p);
			return NULL;
		}
		if((!p->levi) && (!p->desni))
		{
			pom = p->desni;
			free(p);
			return pom;
		}
		if((p->levi) && (!p->desni))
		{
			pom = p->levi;
			free(p);
			return pom;
		}
		if((p->levi) && (p->desni))
		{
			//nadji();
			p->balans = dubina(p->desni) - dubina(p->levi);
			sredi(&p);
			return p;
		}
	}
	return p;
}
*/
int main(){
	struct drvo *p;
	p = form();
	ispis(p);
	
	return(0);
}
