#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct cvor
{
	char ime[20];
	char uspesan[20];
	int tezina;
	int nastup;
	int pevanje;
	int balans;
	float prosek;
	struct cvor *levi, *desni;
}cvor;

int dubina(cvor *p)
{
	int dd=0, dl=0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);	
		if(dl>dd) return ++dl;
		else  return ++dd;

	}else return 0;
}

void lrotacija(cvor **p)
{
	cvor *poml, *pomd;
	poml = *p;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*p = pomd;
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(cvor **p)
{
	cvor *poml, *pomd;
	pomd = *p;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*p = poml;
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}


int dodaj(cvor **p,cvor *k)
{
	
	int inkrement, rezultat=0;
	cvor *t=*p;
	if(t==NULL){
		t=k;
		rezultat=1;
	}else{
		if(k->prosek>t->prosek) inkrement = dodaj(&(t->desni),k);
		else inkrement = -dodaj(&(t->levi),k);
		t->balans += inkrement;
		if(inkrement!=0 && t->balans!=0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}else if(t->balans>1)
				{						
					if(t->desni->balans>0) lrotacija(&t);
					else 
					{
						drotacija(&(t->desni));
						lrotacija(&t);
					}						
				}else rezultat = 1;
		}
	}
	*p=t;
	return rezultat;
}

void izmeni(cvor *koren,char t1[],char t2[]){
	if(koren){
		if(strcmp(koren->ime,t2)==0){
			koren->prosek=(float)(koren->pevanje+koren->tezina+koren->nastup+10)/4;
			if(koren->prosek>5)
				strcpy(koren->uspesan,"uspesan");
		}
		if(strcmp(koren->ime,t1)==0){
			koren->prosek=(float)(koren->pevanje+koren->tezina+koren->nastup+5)/4;
			if(koren->prosek>5)
				strcpy(koren->uspesan,"uspesan");
		}
		if(koren->levi)
			izmeni(koren->levi,t1,t2);
		if(koren->levi)
			izmeni(koren->desni,t1,t2);
	}
}
		
	

cvor *form(cvor *koren){
	int n,i;
	cvor *t,*pom;
	char *tm1="uspesan";
	char *tm2="neuspesan";
	pom=koren;
	printf("n? ");
	scanf("%d",&n);
	for(i=0;i<n;i++){
		t = (cvor*)malloc(sizeof(cvor));
		printf("ime: ");
		scanf("%s",&(t->ime));
		printf("tezina: ");
		scanf("%d",&(t->tezina));
		printf("nastup: ");
		scanf("%d",&(t->nastup));
		printf("pevanje: ");
		scanf("%d",&(t->pevanje));
		if((t->pevanje)>5){
			strcpy(t->uspesan,tm1);
		}
		else{
			strcpy(t->uspesan,tm2);
		}
		t->prosek=(float)(t->pevanje+t->tezina+t->nastup)/3;
		t->balans = 0;
		t->levi=t->desni = NULL;
		dodaj(&pom,t);
	}
	return pom;
}

void print(cvor *koren){
	if(koren){
		print(koren->desni);
		printf("%s\t%d %d %d\t%f\n",koren->ime,koren->tezina,koren->nastup,koren->pevanje,koren->prosek);
		print(koren->levi);
	}
}
/*
void sredi(cvor **p){
	cvor *t=*p;
	if(t->balans < - 1){
		if(t->levi->balans<0) drotacija(&t);
		else{
			lrotacija(&(t->levi));
			drotacija(&t);
		}
	}
	else if(t->balans>1)	{
		if(t->desni->balans>0) lrotacija(&t);
		else{
			drotacija(&(t->desni));
			lrotacija(&t);
		}
	}	
	*p=t;	
}

int nadji(cvor **p){
	cvor *ckrezultat;
	cvor *t=*p;	
	if(!t->levi){		
		rezultat = t;
		t=t->desni;
	}else rezultat = nadji(&(t->levi));
	if(t){
		t->balans = dubina(t->desni) - dubina(t->levi);
		sredi(&t);
	}
	*p = t;
	return (rezultat);
}


cvor *obrisi(cvor *p){
	cvor *t;	
	if(p==NULL) return NULL;
	if(strcmp(p->uspesan,"neuspesan")==0){
		if(!p->levi && !p->desni){
			free(p);
			return NULL;
		}
		if(!p->levi && p->desni){
			t=p->desni;
			free(p);
			return t;
		}
		if(p->levi && !p->desni){
			t=p->levi;
			free(p);
			return t;
		}
		if(p->levi && p->desni)		{
			p = nadji(&(p->desni));
			p->balans = dubina(p->desni) - dubina(p->levi);
			sredi(&p);
			return p;
		}
	}

}		
	


void brisanje(cvor *koren){
	if(koren){
		if(koren->levi)brisanje(koren->levi);
		obrisi(koren);
		if(koren->levi)brisanje(koren->levi);
	}
}
*/

main(){
	cvor *koren=NULL;
	char t1[20],t2[20];
	koren=form(koren);
	print(koren);
	printf("\n5 poena dobio: ");
	scanf("%s",&t1);
	printf("10 poena dobio: ");
	scanf("%s",&t2);
	izmeni(koren,t1,t2);
	print(koren);
}


















