#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{CRVENA, CRNA};

struct drvo{
	struct drvo *levi, *desni, *roditelj;
	char ime[20];
	int tezina, nastup, pevanje, boja;
	char komentar[20];
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

void lrotacija(struct drvo **t){
	struct drvo *x, *y;
	x=*t;
	y=x->desni;
	x->desni=y->levi;
	if(y->levi) y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
		if(x==x->roditelj->desni) x->roditelj->desni=y;
		else x->roditelj->levi=y;
	
	y->levi=x;
	x->roditelj=y;
	*t=y;
}

void drotacija(struct drvo **t){
	struct drvo *x, *y;
	y=*t;
	x=y->levi;
	y->levi=x->desni;
	if(x->desni) x->desni->roditelj=y;
	x->roditelj=y->roditelj;
	if(y->roditelj)
		if(y==y->roditelj->desni) y->roditelj->desni=x;
		else y->roditelj->levi=x;
	
	x->desni=y;
	y->roditelj=x;
	*t=x;
}


void bojefix(struct drvo **p, struct drvo *z){
	struct drvo *y, *t;
	while((z->roditelj) && (z->roditelj->boja==CRVENA)){
		if(z->roditelj==z->roditelj->roditelj->levi){
			y=z->roditelj->roditelj->desni;
			if((y) && (y->boja==CRVENA)){
				y->boja=CRNA;
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else{
				if(z==z->roditelj->desni){
					z=z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->levi;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p=t;
				t=t->desni;
			}
		}
		else{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->boja==CRVENA)){
				y->boja=CRNA;
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else{
				if(z==z->roditelj->levi){
					z=z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->desni;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p=t;
				t=t->desni;
			}
		}
	}
		(*p)->boja=CRNA;
}



void dodaj(struct drvo **koren, struct drvo *cvor){
	struct drvo *x, *y;
	x=*koren;
	y=NULL;
	while(x){
		y=x;
		if(((cvor->tezina+cvor->nastup+cvor->pevanje)/3) < ((x->tezina+x->nastup+x->pevanje)/3)) x=x->levi;
		else x=x->desni;
	}
	cvor->roditelj=y;
	if(!y) *koren=cvor;
	else{
		if(((cvor->tezina+cvor->nastup+cvor->pevanje)/3) < ((y->tezina+y->nastup+y->pevanje)/3)) y->levi=cvor;
		else y->desni=cvor;
	}
	bojefix(koren,cvor);
}

struct drvo *form(){
	struct drvo *cvor, *koren=NULL;
	int n,i,tezina,nastup,pevanje;
	char ime[20];
	int srednja;
	
	scanf("%d", &n);
	for(i=0;i<n;i++){
		novi(cvor);
		scanf("%s", ime);
		scanf("%d", &tezina);
		scanf("%d", &nastup);
		scanf("%d", &pevanje);
		cvor->levi=cvor->desni=NULL;
		cvor->boja=CRVENA;
		strcpy(cvor->ime, ime);
		cvor->tezina=tezina;
		cvor->nastup=nastup;
		cvor->pevanje=pevanje;
		srednja=((cvor->tezina + cvor->nastup + cvor->pevanje)/3);
		if(srednja > 5) strcpy(cvor->komentar, "USPESAN");
		else strcpy(cvor->komentar, "NEUSPESAN");
		dodaj(&koren, cvor);
	}
	return koren;
	
}


void ispis(struct drvo *koren){
	if(koren){
		ispis(koren->desni);
		printf("%s\t", koren->ime);
		if(koren->boja==CRVENA) printf("(CRVENA)\t");
		else printf("(CRNA)\t");
		printf("%s\n", koren->komentar);
		printf("%d\t%d\t%d\n", koren->tezina, koren->nastup, koren->pevanje);
		ispis(koren->levi);
	}
}


struct drvo *najbiliza(struct drvo *koren, int ocena, int naj, struct drvo *najblizi){
	if(koren){
		najbiliza(koren->desni,ocena, naj, najblizi);
		if((koren->pevanje - ocena) < naj)
		
		{naj=(koren->pevanje - ocena); najblizi=koren;}
		printf("%d\t %d\n", koren->pevanje - ocena, naj);
		najbiliza(koren->levi,ocena, naj, najblizi);
	}
	return najblizi;
}





main(){
	struct drvo *koren, *najblizi=NULL;
	int ocena, naj;
	naj=100;
	koren=form();
	ispis(koren);
	
	scanf("%d", &ocena);
	najblizi=najbiliza(koren, ocena, naj, najblizi);
	printf("%s\t %d\t %d\t %d\t",najblizi->ime, najblizi->tezina, najblizi->nastup, najblizi->pevanje);

}


	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
